<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Rating extends Controller_Handler {

        public function before() {
            $this->model = new Model_Teacher_Rating;
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }

        public function action_SetRate()
        {
			$data['success'] = false;
            $this->post -> rule('student', 'not_empty')
                        -> rule('student', 'digit')
                        -> rule('submodule', 'not_empty')
                        -> rule('submodule', 'digit')
                        -> rule('rate', 'digit')
                        -> rule('rate', 'range', array(':value', 0, 100));
            if($this->post->check()) {
                $result = $this->model->SetStudentRate( $this->user['TeacherID'], 
                                                        $this->post->offsetGet('student'), 
                                                        $this->post->offsetGet('submodule'), 
                                                        $this->post->offsetGet('rate'));
				$data['success'] = ($result[0]['Num'] == 0);
            }
            $this->response->body(json_encode($data));
        }

        public function action_SelectGroup(){
            $data['success'] = false;
            $this->post -> rule('disciplineID', 'digit')
                        -> rule('disciplineID', 'not_empty')
                        -> rule('groupSelected', 'digit')
                        -> rule('groupSelected', 'not_empty');
            if($this->post->check()) {
                //$SGID = Cookie::get('SGID', null);
                $SG_json = json_decode(Cookie::get('SGID', null), true);
                
                $SG_json[$this->post->offsetGet('disciplineID')] = $this->post->offsetGet('groupSelected');

                Cookie::set('SGID', json_encode($SG_json), '2592000'); 
                $data['success'] = true;
            }
            $this->response->body(json_encode($data));
        }


        // TODO : ПЕРЕНОС В СВОЙ handler/GenerateFiles.php
        public function action_GetExcelRateTable() {

            // Создаем объект класса PHPExcel
            $xls = new PHPExcel();
            // Устанавливаем индекс активного листа
            $xls->setActiveSheetIndex(0);

            // Получаем активный лист
            $sheet = $xls->getActiveSheet();
            // Подписываем лист
            //$sheet->setTitle('Баллы');

            //$sheet->setCellValue("A1", 'Баллы');

            // Шапка таблицы: структура УКД (модули и мероприятия)
            $structure = $this->model->GetMapForDiscipline($this->user['TeacherID'], $this->post->offsetGet('disciplineID'));

            $structureHandled = array();
            $maxRate = 0; $i = 0; $module = 0;

            foreach($structure as $row)
            {
                if($row['ModuleID'] != $module)
                {
                    $i++;
                    $module = $row['ModuleID'];
                }
                if(!isset($structureHandled[$i]['SubmodulesCount']))
                {
                    $structureHandled[$i]['SubmodulesCount'] = 0;
                    $structureHandled[$i]['MaxRate'] = 0;
                }
                $j = $structureHandled[$i]['SubmodulesCount'] += 1;
                $structureHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
                $structureHandled[$i]['ModuleTitle'] = $row['ModuleName'];
                $structureHandled[$i]['ModuleType'] = $row['ModuleType'];
                        
                $structureHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
                $structureHandled[$i][$j]['Title'] = $row['SubModuleName'];

                $structureHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
                $maxRate += $row['MaxRate'];
            }
            $structureHandled['ModulesCount'] = $i;
            $structureHandled['MaxRate'] = (int) $maxRate;

            $sheet->setCellValueByColumnAndRow(
                0, // Столбец. Индексация с 0
                1, // Строка. Индексация с 1
                'Модуль'
            );

            $sheet->setCellValueByColumnAndRow(
                0,
                2,
                'Мероприятие'
            );

            $sheet->setCellValueByColumnAndRow(
                0,
                3,
                'Макс. балл'
            );

            $SubmodulesCount = 0;
            // Модули
            for ($k = 1; $k <=  $structureHandled['ModulesCount']; $k++)
            {
                if ($k == 1) $pointer = 1;

                $sheet->mergeCellsByColumnAndRow($pointer, 1, $pointer + $structureHandled[$k]['SubmodulesCount'] - 1, 1);

                $sheet->setCellValueByColumnAndRow(
                    $pointer,
                    1,
                    $structureHandled[$k]['ModuleTitle']
                );

                $l = 0;
                // Мероприятия
                for ($l = 1; $l <= $structureHandled[$k]['SubmodulesCount']; $l++)
                {
                    $sheet->setCellValueByColumnAndRow(
                        $pointer + $l - 1,
                        2,
                        $structureHandled[$k][$l]['Title']
                    );

                    $sheet->setCellValueByColumnAndRow(
                        $pointer + $l - 1,
                        3,
                        $structureHandled[$k][$l]['MaxRate']
                    );
                    $SubmodulesCount++;
                }

                $pointer = $structureHandled[$k]['SubmodulesCount'] + 1;
            }

            $sheet->setCellValueByColumnAndRow(
                $SubmodulesCount + 1,
                1,
                'Итог'
            );

            $sheet->mergeCellsByColumnAndRow( $SubmodulesCount + 1, 1,  $SubmodulesCount + 1, 3 );

            // Студенты и их баллы
            $students = $this->model->GetStudentsForRating($this->user['TeacherID'], $this->post->offsetGet('disciplineID'));

            $i_s = 0; $curGroup = 0; $ratesum = 0;

            foreach($students as $row) {
                if ($curGroup !== $row['GroupID']) {
                    $curGroup = $row['GroupID'];
                    $i_s++;
                    $sheet->mergeCellsByColumnAndRow( 0, 3 + $i_s,  $SubmodulesCount + 1, 3 + $i_s );
                    $sheet->setCellValueByColumnAndRow(
                        0,
                        3 + $i_s,
                        $row['GroupNum']." группа"
                    );
                }
                // Студенты
                $i_s++;
                $ratesum += $r['Rate'];

                $sheet->setCellValueByColumnAndRow(
                    0,
                    3 + $i_s,
                    $row['Last'].' '.$row['First'].' '.$row['Second']
                );

                // Баллы студента
                $rate = $this->model->getMapForStudent($row['ID'], $this->post->offsetGet('disciplineID'));
                $i_r = 0;
                foreach($rate as $r) {
                    $i_r++;
                    $sheet->setCellValueByColumnAndRow(
                        $i_r,
                        3 + $i_s,
                        $r['Rate']
                    );
                }

                $sheet->setCellValueByColumnAndRow(
                    $SubmodulesCount + 1, // Столбец. Индексация с 0
                    3 + $i_s,
                    $ratesum
                );

            }


            // Выводим HTTP-заголовки
            $this->response->headers("Expires", "Mon, 1 Apr 1974 05:00:00 GMT" );
            $this->response->headers("Last-Modified", gmdate("D,d M YH:i:s") . " GMT" );
            $this->response->headers( "Cache-Control", " no-cache, must-revalidate" );
            $this->response->headers("Pragma", " no-cache" );
            $this->response->headers("Content-type", " application/vnd.ms-excel" );
            $this->response->headers("Content-Disposition", "attachment; filename=RateTable.xls" );
             
            // Выводим содержимое файла
            $objWriter = new PHPExcel_Writer_Excel5($xls);
            $objWriter->save('php://output');

        }

}